﻿using System;
using System.Collections.Generic;
using System.Data.Services.Client;
using System.Linq;
using System.ServiceModel;
using System.Threading.Tasks;
using NavisionApp.NAVService;
using Windows.Data.Xml.Dom;
using Windows.UI.Xaml.Controls;

// The Items Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234233

namespace NavisionApp
{
    /// <summary>
    /// A page that displays a collection of item previews.  In the Split Application this page
    /// is used to display and select one of the available groups.
    /// </summary>
    public sealed partial class ItemsPage : NavisionApp.Common.LayoutAwarePage
    {
        GetTiles _getTiles = new GetTiles();

        public ItemsPage()
        {
            this.InitializeComponent();
        }

        /// <summary>
        /// Populates the page with content passed during navigation.  Any saved state is also
        /// provided when recreating a page from a prior session.
        /// </summary>
        /// <param name="navigationParameter">The parameter value passed to
        /// <see cref="Frame.Navigate(Type, Object)"/> when this page was initially requested.
        /// </param>
        /// <param name="pageState">A dictionary of state preserved by this page during an earlier
        /// session.  This will be null the first time a page is visited.</param>
        protected override void LoadState(Object navigationParameter, Dictionary<String, Object> pageState)
        {
            // TODO: Assign a bindable collection of items to this.DefaultViewModel["Items"]
            
            this.DefaultViewModel["Items"] = _getTiles.LoadTiles();
        }

       

        private void itemGridView_ItemClick(object sender, ItemClickEventArgs e)
        {
            
            if (e.ClickedItem != null)
            {
                string title = ((TileItem)e.ClickedItem).TileTitle;
                switch (title)
                {
                    case "Customers":
                        this.Frame.Navigate(typeof(SplitPage1), title);
                        break;
                    case "Items":
                        this.Frame.Navigate(typeof(NAVItemsPage), title);
                        break;
                    case "Vendors":
                        this.Frame.Navigate(typeof(VendorPage), title);
                        break;
                    case "Sales":
                        this.Frame.Navigate(typeof(SalesPage), title);
                        break;
                    case "Purchases":
                        this.Frame.Navigate(typeof(PurchPage), title);
                        break;
                    case "Warehouse":
                        this.Frame.Navigate(typeof(Shipments), title);
                        break;

                    default:
                        break;
                }
                
            }

        }
       
       
    }

   
}