﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.ServiceModel;
using NavisionApp.NAVService;


namespace NavisionApp
{
    public class Shipment
    {
        public string shipmentNo { get; set; }

        public string orderNo { get; set; }

        public string custNo { get; set; }

        public string custName { get; set; }

        public string custAddr { get; set; }

        public string custAddr2 { get; set; }

        public string custCity { get; set; }

        public string custState { get; set; }

        public string custZipcode { get; set; }

        public string custCountry { get; set; }

        public string custContactName { get; set; }

        public string postingDate { get; set; }

        public string netWeight { get; set; }

        public string grossWeight { get; set; }

        public string quantity { get; set; }

        public string shipDate { get; set; }

        
    }

    

    public class GetShipments
    {
        private WebServiceHelper webServiceHelper = new WebServiceHelper();

        public List<Shipment> LoadShipments()
        {
            try
            {
                string baseURL = "http://localhost:7047/DynamicsNAV70/WS/CRONUS USA, Inc./Page/ShipmentCard";

                ShipmentCard_PortClient ShipmentCardService = new ShipmentCard_PortClient(webServiceHelper.GetNAVBinding(), new EndpointAddress(baseURL));

                ShipmentCardService.ClientCredentials.Windows.AllowedImpersonationLevel = System.Security.Principal.TokenImpersonationLevel.Delegation;
                ShipmentCardService.ClientCredentials.Windows.ClientCredential.UserName = "win8user";
                ShipmentCardService.ClientCredentials.Windows.ClientCredential.Password = "win8win8";
                ShipmentCardService.ClientCredentials.Windows.ClientCredential.Domain = "WIN8RTM";

                const int fetchsize = 30;

                Task<ReadMultiple_Result> _shipResult = ShipmentCardService.ReadMultipleAsync(new ShipmentCard_Filter[] { }, null, fetchsize);
                ReadMultiple_Result shipResults = _shipResult.Result;

                List<Shipment> navShipments = new List<Shipment>();
                

                foreach (ShipmentCard sh in shipResults.ReadMultiple_Result1)
                {
                    Shipment navShip = new Shipment();
                    navShip.shipmentNo = sh.No;
                    navShip.orderNo = sh.Order_No;
                    navShip.custNo = sh.Sell_to_Customer_No;
                    navShip.custName = sh.Sell_to_Customer_Name;
                    navShip.custAddr = sh.Sell_to_Address;
                    navShip.custAddr2 = sh.Sell_to_Address_2;
                    navShip.custCity = sh.Sell_to_City;
                    navShip.custState = sh.Sell_to_City;
                    navShip.custZipcode = sh.Sell_to_Post_Code;
                    navShip.custContactName = sh.Sell_to_Contact;
                    navShip.postingDate = sh.Posting_Date.Date.ToString();
                          
                    navShipments.Add(navShip);
                }

                return navShipments;
            }
            catch (Exception)
            {
                throw;
            }
        }

        public List<Shipment> SearchShipments(string searchString)
        {
            try
            {
                string baseURL = "http://localhost:7047/DynamicsNAV70/WS/CRONUS USA, Inc./Page/ShipmentCard";

                ShipmentCard_PortClient ShipmentCardService = new ShipmentCard_PortClient(webServiceHelper.GetNAVBinding(), new EndpointAddress(baseURL));

                ShipmentCardService.ClientCredentials.Windows.AllowedImpersonationLevel = System.Security.Principal.TokenImpersonationLevel.Delegation;
                ShipmentCardService.ClientCredentials.Windows.ClientCredential.UserName = "win8user";
                ShipmentCardService.ClientCredentials.Windows.ClientCredential.Password = "win8win8";
                ShipmentCardService.ClientCredentials.Windows.ClientCredential.Domain = "WIN8RTM";

                const int fetchsize = 30;

                ShipmentCard_Filter filter = new ShipmentCard_Filter();
                filter.Field = ShipmentCard_Fields.Sell_to_Customer_Name;
                filter.Criteria = "@*" + searchString + "*";

                ShipmentCard_Filter[] filters = new ShipmentCard_Filter [] { filter };

                Task<ReadMultiple_Result> _shipResult = ShipmentCardService.ReadMultipleAsync(filters, null, fetchsize);
                ReadMultiple_Result shipResults = _shipResult.Result;

                List<Shipment> navShipments = new List<Shipment>();


                foreach (ShipmentCard sh in shipResults.ReadMultiple_Result1)
                {
                    Shipment navShip = new Shipment();
                    navShip.shipmentNo = sh.No;
                    navShip.orderNo = sh.Order_No;
                    navShip.custNo = sh.Sell_to_Customer_No;
                    navShip.custName = sh.Sell_to_Customer_Name;
                    navShip.custAddr = sh.Sell_to_Address;
                    navShip.custAddr2 = sh.Sell_to_Address_2;
                    navShip.custCity = sh.Sell_to_City;
                    navShip.custState = sh.Sell_to_City;
                    navShip.custZipcode = sh.Sell_to_Post_Code;
                    navShip.custContactName = sh.Sell_to_Contact;
                    navShip.postingDate = sh.Posting_Date.Date.ToString();

                    navShipments.Add(navShip);
                }

                return navShipments;
            }
            catch (Exception)
            {
                throw;
            }
        }
    }
}
