﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.ServiceModel;
using Windows.UI.Popups;
using Windows.UI.Xaml;



namespace NavisionApp
{
    class WebServiceHelper
    {

        public BasicHttpBinding GetNAVBinding()
        {

            try
            {
                // Create a NAV comatible binding
                BasicHttpBinding NAVWSBinding = new BasicHttpBinding();
                NAVWSBinding.Security.Mode = BasicHttpSecurityMode.TransportCredentialOnly;
                NAVWSBinding.Security.Transport.ClientCredentialType = HttpClientCredentialType.Windows;
                NAVWSBinding.MaxReceivedMessageSize = 1200000;
                return NAVWSBinding;
            }
            catch (Exception)
            {
                
                throw;
            }
            
        }

        public async void LaunchNavision(int PageID,string TableKey)
        {
            try
            {
                var messageDialog = new MessageDialog("You are about to Launch Navision Client");


                messageDialog.Commands.Add(new UICommand(
                    "OK",
                    new UICommandInvokedHandler(this.CommandInvokedHandler),PageID));
                messageDialog.Commands.Add(new UICommand(
                    "Cancel",
                    new UICommandInvokedHandler(this.CommandInvokedHandler),0));

                messageDialog.DefaultCommandIndex = 0;

                messageDialog.CancelCommandIndex = 1;

                // Show the message dialog
                await messageDialog.ShowAsync();
            }
            catch (Exception)
            {
                
                throw;
            }
           

        }

        public async void ReceiptCreated(string msg)
        {
            try
            {
                var messageDialog = new MessageDialog(msg);


                messageDialog.Commands.Add(new UICommand(
                    "OK",
                    new UICommandInvokedHandler(this.RcptCommandInvokedHandler)));
               

                messageDialog.DefaultCommandIndex = 0;

                messageDialog.CancelCommandIndex = 1;

                // Show the message dialog
                await messageDialog.ShowAsync();
            }
            catch (Exception)
            {

                throw;
            }


        }

        private void RcptCommandInvokedHandler(IUICommand command)
        {
            try
            {
                switch (command.Label)
                {
                    case "OK":
                        
                        break;
                    case "Cancel":
                        break;
                    default:
                        break;

                }
            }
            catch (Exception)
            {

                throw;
            }


        }
        private void CommandInvokedHandler(IUICommand command)
        {
            try
            {
                switch (command.Label)
                {
                    case "OK":
                        LaunchApp((int)(command.Id));
                        break;
                    case "Cancel":
                        break;
                    default:
                        break;

                }
            }
            catch (Exception)
            {
                
                throw;
            }
            
            
        }

        private async void LaunchApp(int pageID)
        {
            
            string uriToLaunch = @"DynamicsNAV:////runpage?page=" + pageID.ToString();
            var uri = new Uri(uriToLaunch);
            await Windows.System.Launcher.LaunchUriAsync(uri);
                    
            
        
        }

    }
}
